@echo off
rem Upgrade script for svn WC @ 17a to 17b (single DB)

rem author Oto BREZINA
rem (c) 2010

rem version 0.1 first approach

rem This script does not preserve conflict state
rem This script does not preserve properties changes
rem one of weak point of this script is move, WC may be still locked after update - probably by TortoiseSVN

rem global variables-constans
Set DIR_WC17A=17a
Set DIR_WC17B=17b
Set TEMPFILE=svn_upg_tmp.txt
Set FILTERFILE=export_filter

rem if parameter set it is single dir to convert
If not "%1" == "" (
	call:wcu_upgrade %1
	goto:eof
)

rem scan actual dir for WCs
for /D %%a in (*.*) DO (
	call:wcu_upgrade %%a
)

Goto:eof

:wcu_upgrade

rem prepare some dirs and files
MkDir %DIR_WC17A%
MkDir %DIR_WC17B%
Echo /.svn/ > %FILTERFILE%

Set WC=%1

Rem get URL from WC
Svn-17a info %WC% | FindStr "URL" > %TEMPFILE%
If ERRORLEVEL 1 (
	Echo %WC% error: not correct WC to upgrade
	Goto:eof
)
Set /p URLLINE= < %TEMPFILE%
Call:wcu_GetParam2 %URLLINE%
Set URL=%PAR2%
Echo URL: %URL%

Rem make sure wc is @ HEAD
rem goto:wcu_upgrade_skip_update
Echo %WC%: Updating
Svn-17a update %WC%
If ERRORLEVEL 1 (
	rem this never happen
	Echo %WC% looks corrupped
	Goto:eof
)
:wcu_upgrade_skip_update


Rem move WC to with old WCs
Echo %WC%: Moving
Move %WC% %DIR_WC17A%\%WC%
If ERRORLEVEL 1 (
	rem this never happen
	Echo %WC%: move error
	Goto:eof
)

Rem get actaul wc from repository
Rem if repository is too active can be set for revision, but would not work for externals
Echo %WC%: Checking out
Svn-17b checkout %URL% %DIR_WC17B%\%WC%\
Rem copy all non svn
Xcopy %DIR_WC17A%\%WC% %DIR_WC17B%\%WC% /s /f /y /exclude:%FILTERFILE%


Goto:eof
rem -------------------------------------------------------------------------

rem there must be better way to do this, but this works too :)
:wcu_GetParam2
Set PAR1=%1
Set PAR2=%2
goto:eof
rem -------------------------------------------------------------------------
